MODULE GameOfLife
	IMPLICIT NONE

CONTAINS

    FUNCTION ALIVE(Feld)
	    INTEGER, DIMENSION(3,3)::Feld
	    LOGICAL:: ALIVE
	    INTEGER::s
	
	    s=SUM(Feld)
	    IF (Feld(2,2)==1) THEN
		    ALIVE= s==3 .OR. s==4
	    ELSE
		    ALIVE = s==3
	    END IF
    END FUNCTION

    FUNCTION ALIVE2(Feld,B,S)
	    INTEGER, DIMENSION(3,3)::Feld
      INTEGER, DIMENSION(:) :: B, S
	    LOGICAL:: ALIVE2
	    INTEGER::summe, i
	
	    summe=SUM(Feld)
	    IF (Feld(2,2)==1) THEN
        ALIVE2 = ANY(S == summe) 
	    ELSE
		    ALIVE2 = ANY(B == summe)
	    END IF
    END FUNCTION

    FUNCTION GameOfLifeStep(Feld)
	    INTEGER,DIMENSION(:,:)::Feld
	    INTEGER,DIMENSION(SIZE(Feld,1),SIZE(Feld,2))::GameOfLifeStep
	    INTEGER:: i,j,m
	    m=SIZE(Feld,2)
	    GameOfLifeStep=0
	    DO i=2,Size(Feld,1)-1
		    Do j=2,m-1
			    IF (ALIVE2(Feld(i-1:i+1,j-1:j+1), (/3/), (/3,4/))) THEN
				    GameOfLifeStep(i,j)=1
			    END IF
		    END DO
	    END DO
    END FUNCTION

    FUNCTION GoLCshift(Feld)
        INTEGER,DIMENSION(:,:):: Feld
        INTEGER,DIMENSION(SIZE(Feld,1),SIZE(Feld,2)):: GoLCshift,Neighs
        INTEGER:: i,j
        Neighs=0
        GoLCshift=0
        DO i=-1,1
            DO j=-1,1
                IF (i==0 .AND. j==0) CYCLE
                Neighs=Neighs+Cshift(Cshift(Feld,i,1),j,2)
            END DO
        END DO
        WHERE (Neighs==3 .OR. (Feld==1 .AND. Neighs==2))
            GoLCshift=1
        END WHERE
    END FUNCTION


    SUBROUTINE show(Feld)
	    INTEGER,DIMENSION(:,:)::Feld
	    INTEGER::i,j,n
	    n=SIZE(Feld,1)
	    DO i=2,size(Feld,2)-1
		    Do j=2,n-1
			    WRITE(*,'(A)',ADVANCE='NO') '+---'
		    END DO
		    WRITE(*,'(A)',ADVANCE='YES')'+'
		    DO j=2,n-1
			    IF (Feld(i,j)==1) THEN
				    WRITE(*,'(A)',ADVANCE='NO')'| O '
			    ELSE
				    WRITE(*,'(A)',ADVANCE='NO') '|   '
			    END IF
		    END DO
		    WRITE(*,'(A)',ADVANCE='YES') '|'
	    END DO
	    Do j=2,n-1
			    WRITE(*,'(A)',ADVANCE='NO') '+---'
	    END DO
	    WRITE(*,'(A)',ADVANCE='YES')'+'
	    WRITE(*,*)
    END SUBROUTINE
			


END MODULE

PROGRAM TEST
	USE GameOfLife
	IMPLICIT NONE
	
	INTEGER,DIMENSION(0:7,0:7):: Feld,Feldt
	INTEGER:: i
	
	Feld=0
	Feld(4,2:4)=1
	FELD(3,4)=1
	Feld(2,3)=1
    FELdt =Feld
	CALL show(Feld)
	DO i=1,4
		Feld=GameOfLifeStep(Feld)
		Call show(Feld)
	END DO
    WRITE(*,*) '2.Feld'
    CALL show(Feldt)
    DO i=1,4
        Feldt=GoLCshift(Feldt)
        Call show(Feldt)
    END DO
END PROGRAM
