PROGRAM schnitt
  IMPLICIT NONE
  !INTEGER,PARAMETER:: qd = SELECTED_REAL_KIND(18,4931)
  integer::  ios33, i, iosread
  !REAL(KIND=qd):: fib_last, fib2nd, quotient, x
  REAL:: fib_last, fib2nd, quotient, x

  OPEN(UNIT=33, IOSTAT=ios33, STATUS="REPLACE", ACTION="WRITE", FILE="fib.txt")

  IF(ios33 == 0) THEN
    fib_last = 0.0
    fib2nd = 1.0
    DO i = 1, 100
      quotient = (fib_last / fib2nd)
      !IF(quotient < 1) THEN
      !  WRITE(*,*) 'Real overflow at cycle ', i, '.'
      !  EXIT
      !END IF
      WRITE(UNIT=33,FMT=*,IOSTAT=iosread) quotient

      IF(iosread /= 0) EXIT
      x = fib2nd
      fib2nd = fib_last
      fib_last = fib_last + x
    END DO
  ELSE
    WRITE(*,*) 'ERROR: Cannot open file.'
  END IF

  CLOSE(33)

  WRITE(*,*) vergleich('Zwischenergebnisse1.txt','Zwischenergebnisse2.txt')
  WRITE(*,*) vergleich('Zwischenergebnisse1.txt','Zwischenergebnisse3.txt')
  WRITE(*,*) vergleich('Zwischenergebnisse2.txt','Zwischenergebnisse3.txt')
  WRITE(*,*) vergleich('fib.txt','Zwischenergebnisse1.txt')
  WRITE(*,*) vergleich('fib.txt','Zwischenergebnisse2.txt')
  WRITE(*,*) vergleich('fib.txt','Zwischenergebnisse3.txt')

CONTAINS

  FUNCTION vergleich(x,y)
    CHARACTER(LEN=*):: x,y
    LOGICAL:: vergleich
    INTEGER:: ios36, ios37, i
    !REAL(KIND=qd):: value36, value37
    REAL:: value36, value37

    OPEN(UNIT=36, FILE=TRIM(x), IOSTAT=ios36, STATUS='OLD', ACTION='READ')
    OPEN(UNIT=37, FILE=TRIM(y), IOSTAT=ios37, STATUS='OLD', ACTION='READ')

    IF(ios36==0.AND.ios37==0) THEN
      DO i = 1, 100
        READ(UNIT=36, FMT=*, IOSTAT=ios36) value36
        READ(UNIT=37, FMT=*, IOSTAT=ios37) value37
        IF(ios36==0 .AND. ios37==0) THEN
           IF(value36 /= value37) THEN
             vergleich = .false.
             EXIT
           END IF
        ELSE IF((ios36==0.AND.ios37/=0).OR.(ios36/=0.AND.ios37==0)) THEN
          vergleich = .false.
        ELSE
          vergleich = .true.
        END IF
      END DO
    ELSE
      WRITE(*,*) 'ERROR: Cannot open file.'
    END IF
    CLOSE(36)
    CLOSE(37)
  END FUNCTION vergleich

END PROGRAM
